from .operation import *


def get_control_schema(name: str) -> dict[str, dict[str, Any]]:
    return { 'control' : {'type': 'str' , 'optional': False , 'readonly': False} }


def get_control(name: str) -> dict[str, Any]:
    e = read(name, f"select * from controls")
    return { 'control': e['control'] }


def set_control_cache(name: str, cs: ChangeSet) -> SqlChangeSet:
    old = get_control(name)

    redo_sql = f"update controls set control = '{cs.operations[0]['control']}' where control = '{old['control']}';"
    undo_sql = f"update controls set control = '{old['control']}' where control = '{cs.operations[0]['control']}';"

    redo_cs = g_update_prefix | { 'type': 'control', 'control': cs.operations[0]['control'] }
    undo_cs = g_update_prefix | { 'type': 'control', 'control': old['control'] }

    return SqlChangeSet(redo_sql, undo_sql, redo_cs, undo_cs)


def set_control(name: str, cs: ChangeSet) -> ChangeSet:
    return execute_command(name, set_control_cache(name, cs))
